import greenfoot.*;
import java.util.*;

public class Nave  extends Actor
{
    static int vida = 100;    
    private int dir;
    static int mouseX;
    static int mouseY;
    private double x, y;
    private boolean shoot;
    private int freqClick;
    MouseInfo mouse;
    
    public Nave() 
    {
        vida = 100;
    }
    
    protected void addedToWorld(World world) 
    {
        getWorld().addObject(new BarLive("playerhealth"),164,12);
    }
    
    public void act() 
    {
        movimiento();
        dispara();
        getShot();
    }    
    
    public void movimiento() 
    {
        if(Greenfoot.isKeyDown("w"))//move up
            setLocation(getX(), getY() - 3);
        if(Greenfoot.isKeyDown("s")) //move down
            setLocation(getX(), getY() + 3);
        if(Greenfoot.isKeyDown("a"))//move left
            setLocation(getX() - 3, getY());
        if(Greenfoot.isKeyDown("d")) //move right
            setLocation(getX() + 3, getY());
        
        if(Greenfoot.mouseMoved(null)) 
        {
            mouse = Greenfoot.getMouseInfo();
            mouseX = mouse.getX();
            mouseY = mouse.getY();
        }
        setRotation(apunta(mouseX,mouseY));
    }
    
    public void dispara() 
    {
        if(Greenfoot.mousePressed(null)) 
        {
            shoot = true;
            freqClick = 15;
        }
        
        if(Greenfoot.mouseClicked(null))
            shoot = false;
            freqClick++;
            
        if(shoot == true && freqClick >= 15) 
        {
            getWorld().addObject(new Bala((getRotation() - 5) + Greenfoot.getRandomNumber(10)),getX(),getY());
            freqClick = 0;
            Greenfoot.playSound("Laser-2.wav");
        }
    }
       
    public int apunta(int x, int y) 
    {
        int dX = x - getX();
        int dY = y - getY();
        double rotation = Math.atan2(dY, dX); 
        rotation = Math.toDegrees(rotation); 
        return (int)rotation;
    }
    
    public void getShot() 
    {
        Bala2 bullet = (Bala2)getOneIntersectingObject(Bala2.class);
        Space space = (Space) getWorld();
        
        if(bullet != null && vida >= 0 ) 
        {   
            for(int i=0;i<Greenfoot.getRandomNumber(50)+50;i++)
                getWorld().addObject(new Fire(bullet.dir,Greenfoot.getRandomNumber(5) + 5,Greenfoot.getRandomNumber(5) + 5),getX(),getY()); 
            vida-=3;
            getWorld().removeObject(bullet);
            
            if(vida <= 0)
            {
              for(int n=0;n<=3;n++)
                 getWorld().addObject(new NaveParts("1",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
             
                 getWorld().removeObject(this);
                 Greenfoot.playSound("explosion.wav");
                 space.gameOver();
            }
        } 
    }
}
