import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class NaveParts here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class NaveParts  extends Actor
{
    private String part;
    private int rot;
    private int vel;
    private int time;
    private int dir;
    private int num;
    private double x,y;
    
    public NaveParts(String part,int vel,int time,int rot,int dir) 
    {
        this.part = part;
        this.vel = vel;
        this.time = time;
        this.rot = rot;
        this.dir = dir;
        num = Greenfoot.getRandomNumber(2);
        if(part.equals("1"))
            setImage("NaveParts.png");
    }
    
    protected void addedToWorld(World world) 
    {
        x = getX();
        y = getY();
    }
    
    public void act() 
    {
        time--;
        if(time > 0) 
        {
            if(num == 0)
                rot+=10;
            else
                rot-=10;
            setRotation(rot);
            movement();
            for(int i=0;i<Greenfoot.getRandomNumber(25) + 25;i++)
                getWorld().addObject(new Fire(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5)+2,Greenfoot.getRandomNumber(5)+2),(getX()- 5) + Greenfoot.getRandomNumber(10),(getY()- 5) + Greenfoot.getRandomNumber(10));
        }
    }    
    
    public void movement() 
    {
        double angle = Math.toRadians(dir);
        x+=Math.cos(angle)*vel;
        y+=Math.sin(angle)*vel;
        setLocation((int)Math.round(x), (int)Math.round(y));
    }
}
