import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Ovni here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ovni  extends Actor
{
    private double x, y;
    private int dir;
    private int vidaOvni = 100;
    private boolean shoot;
    
    public Ovni(int Direction) 
    {
        dir = Direction;
    }
    
    protected void addedToWorld(World world) 
    {
        x = getX();
        y = getY();
        setRotation(dir);
    }
    
    public void act() 
    {
        dir = getRotation();
        MovementNave();
        cambiaImagen();
        disparaOvni(); 
        getShot();
    }    
    
    public void MovementNave() 
    {
        List<Nave> Player = getWorld().getObjects(Nave.class);
        
        if(Player.size() > 0) 
        {
            Nave nave = Player.get(0);
            setRotation(apunta(nave.getX(),nave.getY()));
            sigueNave();
        } 
    }
    
    public int apunta(int x, int y) 
    {
        int dX = x - getX(); 
        int dY = y - getY(); 
        double rotation = Math.atan2(dY, dX); 
        rotation = Math.toDegrees(rotation); 
        return (int)rotation; 
    } 

    public void sigueNave() 
    {
        List<Nave> Nave = getObjectsInRange(100,Nave.class);
        
        if(Nave.size() == 0) 
        {
            double angle = Math.toRadians(getRotation());
            x+=Math.cos(angle);
            y+=Math.sin(angle);
            setLocation((int)Math.round(x), (int)Math.round(y));
        } 
    }
    
    public void getShot() 
    {
        Bala bullet = (Bala)getOneIntersectingObject(Bala.class);
        
        if(bullet != null && vidaOvni >= 0 ) 
        {   
            for(int i=0;i<Greenfoot.getRandomNumber(50)+50;i++)
                getWorld().addObject(new Fire(bullet.dir,Greenfoot.getRandomNumber(5) + 5,Greenfoot.getRandomNumber(5) + 5),getX(),getY()); 
            vidaOvni-=20;
            getWorld().removeObject(bullet);
            
            if(vidaOvni <= 0)
            {
                for(int j=0;j<Greenfoot.getRandomNumber(100)+100;j++)   
                    getWorld().addObject(new Fire(Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(8) + 2),getX(),getY());
                getWorld().removeObject(this);
                Greenfoot.playSound("explosion.wav");  
            }
        } 
    }

    public void cambiaImagen() 
    {
        if(vidaOvni >= 75)
            setImage(new GreenfootImage("Ovni[1].png"));
        if(vidaOvni < 75 && vidaOvni >= 50)
            setImage(new GreenfootImage("Ovni[2].png"));
        if(vidaOvni < 50 && vidaOvni >= 25)
            setImage(new GreenfootImage("Ovni[3].png"));
        if(vidaOvni < 25 && vidaOvni > 0)
            setImage(new GreenfootImage("Ovni[4].png"));
    }

    public void disparaOvni() 
    {
        shoot = true;
        int vel= Greenfoot.getRandomNumber(100);   
        
        if(shoot == true && vel == 0) 
        {
            getWorld().addObject(new Bala2((getRotation() - 5) + Greenfoot.getRandomNumber(10)),getX(),getY());
            Greenfoot.playSound("saber_on.wav");
        }    
    }
}
