import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Space here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Space  extends World
{
    private int cont;
    private int frec = 70;
    private boolean band = false;
    static int numOvnis;
    static int numNivel = 0;
    private int ovniNiv = 5;
    private int startcont;
    boolean band2;
    boolean band3;
    
    public Space() 
    {
        super(700,416,1,false); 
        animation();
    }
    
    public void animation()
    {
        Greenfoot.playSound("Theme0.wav");
        removeObjects(getObjects(null));
        setBackground("alienAtack.png");
        addObject(new Play(),200,300);
        addObject(new Help(),400,300);
    }
      
    public void help()
    {
        removeObjects(getObjects(null));
        setBackground("ayuda.png");
        addObject(new Play(),300,360);
    } 
    
    public void start()
    {       
        removeObjects(getObjects(null)); 
        setBackground("space1.jpg");
        setPaintOrder(Target.class,Text.class,BarLive.class,Ovni.class,Nave.class,NaveParts.class,Fire.class,numNivel.class,Winner.class,GameOver.class);
        addObject(new Nave(),(getWidth()/2) + 10,getHeight()/2);
        addObject(new Target(),(getWidth()/2) + 100,getHeight()/2);
        frec = 70;
        numNivel= 0;
        band2=true;
    }   
        
    
    public void gameOver()
    {
        removeObjects(getObjects(null));
        addObject(new GameOver(),(getWidth()/2-50),(getHeight()/2));
        numOvnis = 0;
        band2=false;
        band3=false;
    }
    
    public void winner()
    {
     numOvnis = 0;
     removeObjects(getObjects(null));
     band2 = false;
     band3 = false;
     addObject(new Winner(),(getWidth()/2),getHeight()/2);
    }
    
    public void act() 
    {
        List<Ovni> onSpace = getObjects(Ovni.class);
        int num;
        
        if(band2 || band3)
        {
        if(band) 
        {
            cont++;
            if(cont == frec) 
            {
                num = Greenfoot.getRandomNumber(4);
                
                switch(num)
                {
                case 0: addObject(new Ovni(0),0,Greenfoot.getRandomNumber(415));
                break;    
                case 1: addObject(new Ovni(0),Greenfoot.getRandomNumber(700),0);
                break;
                case 2: addObject(new Ovni(0),700,Greenfoot.getRandomNumber(415));
                break;
                case 3: addObject(new Ovni(0),Greenfoot.getRandomNumber(700),415);
                }
                
                cont = 0;
                numOvnis--;
                if(numOvnis == 0)
                    band = false;
            }
        } 
        else 
        if(onSpace.size() == 0) 
        {
            startcont++;
            if(startcont == 300) 
            {
                band = true;
                numNivel++;
                numOvnis = numNivel*ovniNiv;
                
                if(numOvnis == 20 || numNivel== 4)
                   winner();
                else
                {
                if(frec > 15)
                    frec -= 5;
                addObject(new numNivel(),(getWidth()/2),getHeight()/2);
                startcont = 0;
                }
            }
        }
    }
}
}
